#!/python/bin

import astropy.io.fits as py
from pylab import *
import matplotlib.pyplot as plt
from datetime import datetime as dt
from datetime import date
import calendar
import astrodate
import time
import glob
import os
import pysynphot as S
from matplotlib.backends.backend_pdf import PdfPages

def UseafterToday():
    ''' Takes the current day ad uses it to fill the useafter_var
    '''
    months=dict((k,v) for k,v in enumerate(calendar.month_abbr))
    localtime = time.localtime(time.time())
    return  months[localtime.tm_mon] + ' ' + str(localtime.tm_mday) + ' ' + str(localtime.tm_year)


def toYearFraction(date):
    def sinceEpoch(date): # returns seconds since epoch
        return time.mktime(date.timetuple())
    s = sinceEpoch

    year = date.year
    startOfThisYear = dt(year=year, month=1, day=1)
    startOfNextYear = dt(year=year+1, month=1, day=1)

    yearElapsed = s(date) - s(startOfThisYear)
    yearDuration = s(startOfNextYear) - s(startOfThisYear)
    fraction = yearElapsed/yearDuration

    return date.year + fraction

def mjdDate2(date):
    #s_date = date.split()
    #date=''
    #if len(s_date) > 2:
        #    for s in xrange(2): date += s_date[s] + ' '
        #date += s_date[2]
        #print ' the date is =',date
    #ua_time=time.strptime(date, "%b %d %Y")
    ua_time=date
    ua_date = datetime.datetime(ua_time.year,ua_time.month, ua_time.day)
    year_frac =toYearFraction(ua_date)
    return astrodate.JulianDate(year_frac).mjd

def mjdDate(date):

    s_date = date.split()
    date=''
    if len(s_date) > 2:
        for s in xrange(2): date += s_date[s] + ' '
        date += s_date[2]
        print ' the date is =',date
    ua_time=time.strptime(date, "%b %d %Y")
    ua_date = datetime.datetime(ua_time.tm_year,ua_time.tm_mon, ua_time.tm_mday)
    year_frac =toYearFraction(ua_date)
    return astrodate.JulianDate(year_frac).mjd


def dateNum(useafter_date):
    '''
    Acepts and string in the form Month day year hh:mm:ss where Month is
    the abreviated form of the monh name. It converts this sring to a
    dictioary with  year, month, day, hour, minute, seconds
    '''
    months=dict((k,v) for k,v in enumerate(calendar.month_abbr))

    month_1, day_1, year_1 = useafter_date.split


rootdir = '/grp/hst/cdbs/work/wfc3/'
rootname = 'wfc3'
figrootname = 'wfc3_fig_'

files = glob.glob(rootdir+rootname+'*.fits')
filetype='f'

print('The files are ----',files)

# find the filter name of the file
l1 = files[0].find('_'+filetype)
if l1 > 0:
    wavfile0 = filetype+files[0][l1+2:l1+6]
    print wavfile0
else :  wavfile0 = ''
subfiles=[]
for i in xrange(len(files)):
    print xrange(len(files))
    #for i in xrange(10):

    #assumes the files are in alphabetical order
    ft = '_'+filetype
    l1 = files[i].find(ft)
    fq = files[i][l1+2:l1+3]

    # if it found the pattern and the next letter is q then account that on the
    # name
    if fq == 'q' and l1 != -1:
        wavfile = filetype + 'q'+files[i][l1+3:l1+7]
    elif fq != 'q' and l1 != -1: # if the second value is not q account for that
        wavfile = filetype +files[i][l1+2:l1+6]
    elif l1 == -1: # if didn't find the value then assing a dummy value
        wavfile = '-'

    print 'wavfile =',wavfile


    #if the files have equal wavelength, group them
    if wavfile ==  wavfile0 and l1 > 0:
        subfiles.append(files[i])
        files[i]
    elif wavfile0 == '':
        l1 = files[i].find('_'+filetype)
        if l1 > 0:
            wavfile0 = filetype+files[i][l1+2:l1+6]
            subfiles.append(files[i])
        else :  wavfile0 = ''
    elif l1 > 0:
        l1 = files[i].find('_'+filetype)
        # Define name of output figure and put multiple PDF figures there
        figurename = figrootname + files[i][l1-4:l1] + '_' + wavfile + '.pdf'
        pp = PdfPages(figurename)

        wavfile0 = wavfile

        #============= NOT DONE NOW ==================#
        # Find the fles that have extension f1 and ignore them
        subsubfiles=[]
        for j in xrange(len(subfiles)):
             fl2 = subfiles[j].find('f1_')
             fl3 = subfiles[j].find('f2_')
             fl4 = subfiles[j].find('_bkg_')
             fl5 = subfiles[j].find('_th.fits')
             if logical_or.reduce([(fl2 != -1),(fl3 != -1),(fl4 != -1), (fl5 != -1)]):
                print 'Rejected =', subfiles[j]
                pass
             else:
                subsubfiles.append(subfiles[j])

        for h in xrange(len(subsubfiles)): print subsubfiles[h]

        # initialize tuples and varibles and arrays for wavelength and
        # throughput
        wmin0=1000.0
        wmax0=0.0
        wlen=[]
        nrowslen=[]
        mjd=[]
        useafter_in=[]
        ww = np.array([],dtype = float64)
        tt = np.array([],dtype = float64)
        useafter_in.append('Dec  7 2006')
        useafter_in.append('Dec  5 2007')

        #plt.clf()
        print '---3---in here'
        print 'subfiles =',subsubfiles
        #for j in xrange(len(subsubfiles)):
        range0 =[1]
        for j in xrange(len(range0)):
            filein = py.open(subsubfiles[j])   # open file
            data = filein[1].data       # read data
            # get min an max wavlength values
            wmin=np.log10(np.amin(data.field('WAVELENGTH')))
            wmax=np.log10(np.amax(data.field('WAVELENGTH')))

            # Gets min and max wavelengths for all the availale files
            #of the same  filter
            if wmin < wmin0:
                 wmin0 = wmin
            if wmax > wmax0:
                 wmax0 = wmax

            # saves the original size of the array
            wlen.append(len(data.field('WAVELENGTH')))

            # Appends all the wavelenghts and throughputs in a single file
            ww = np.append(ww, np.array(data.field('WAVELENGTH'), dtype=float64), axis = 0)
            tt = np.append(tt, np.array(data.field('THROUGHPUT'), dtype=float64), axis = 0)

            # takes only one of the wavelength ranges, the last. This weill be
            # used, together with the  throughput of the last file as input for
            # the first version of this files.
            ww_p = np.array(data.field('WAVELENGTH'), dtype=float64)
            tt_p = np.array(data.field('THROUGHPUT'), dtype=float64)

            #number of rows per input file
            nrowslen.append(data.shape[0])

            #extract useafter date from fies and use it to calculate the  MJD
            # for the  column names of the mjd file.
            ua=filein[0].header['useafter']
            useafter_in.append(ua)

            today = date.today()
            #useafter_in.append(today)
            #ua_mjd = mjdDate(ua)
            print 'today =',today
            mjd.append(54076.23)
            mjd.append(54439.48)
            mjd.append(55995.36)
            ua_mjd = mjdDate2(today)
            #mjd.append(ua_mjd)
            print '-------------mjd ----',mjd
            print ' useafter ===',useafter_in
            # extracts other useful keywrds
            dbtable = filein[0].header['dbtable']
            descrip = filein[0].header['descrip']
            compname= filein[0].header['compname']
            pedigree = filein[0].header['pedigree']
            instrument =filein[0].header['instrume']
            prihdr = filein[0].header

            filein.close()

        # define output filename
        subfiles[j]=files[i] # adden on may 19 2016
        print files[j]
        l3 = subsubfiles[j].find('_syn')
        l4 = subsubfiles[j].find('_0')
        l5 = subsubfiles[j].rfind('/')
        file_ver = int(subsubfiles[j][l4+1:l4+3])
        file_ver += 1
        #----work  around -----#
        file_ver = 6

        print 'sufiles for outfile =',subsubfiles[j][l5+1:l4+1]
        outfile = subsubfiles[j][l5+1:l4+1] + 'mjd_00' + str.lstrip(str(file_ver)) + '_syn.fits'
        #outfile = subsubfiles[j][l5+1:l4+1] + '00' + str.lstrip(str(file_ver)) + '_syn.fits'
        if os.access(outfile, os.R_OK):
            os.remove(outfile)

        print 'outfile =',outfile

        # Define primary heder and add the needed keywords
        compname += '_m'
        newhdu= py.PrimaryHDU()
        newhdu.header.update('DBTABLE',dbtable, 'Synphot database name')
        newhdu.header.update('EXTRAP',True,'True: linear extrapolation')
        newhdu.header.update('DESCRIP',descrip)
        newhdu.header.update('COMPNAME',compname)
        newhdu.header.update('USEAFTER',UseafterToday())
        newhdu.header.update('PEDIGREE',pedigree)
        newhdu.header.update('INSTRUME',instrument)
        newhdu.header.update('COMMENT ','= Reference file created by R.Diaz', after='instrume')
        # Copies the history from the latest file and adds new input
        for  l in xrange(len(prihdr)-15):
            newhdu.header.add_history(prihdr[l+13])
        comment0 = str(filein[0].header['comment'])
        print 'the comment 0=',comment0
        newhdu.header.add_history('  Previos file '+ comment0)
        newhdu.header.add_history(' ')
        newhdu.header.add_history('  Updated on ' + UseafterToday())
        newhdu.header.add_history(' ')
        newhdu.header.add_history('  New columns to suppor MJD calculations were added these are for')
        str_mjd=''
        for l in xrange(len(mjd)):
            print useafter_in[l],mjd[l]
            str_mjd = str(useafter_in[l]) + '=' + str("%.2f" % mjd[l]) + ';'
            newhdu.header.add_history('MJDs:' + str_mjd)
        newhdu.header.add_history('but the data is the same and equal to MJD'
                 + str("%.2f" % mjd[len(mjd)-1]))
        newhdu.header.add_history(' ')

        # Defines columns and asign their values
        col1= py.Column(name='WAVELENGTH', format='E', array=ww_p,
                unit='ANGSTROMS', disp='G15.7')
        col2= py.Column(name='THROUGHPUT', format='E', array=tt_p,
                unit='TRANSMISSION', disp='G15.7')
        cols0 = [col1,col2]

        #fo now it puts the same information for all the MJDs
        #in this case these thrghput corresponds to the newest file
        name_col = 'MJD#' + str("%.2f" % mjd[0])
        print name_col
        col3= py.Column(name=name_col, format='E', array=tt_p,
                unit='TRANSMISSION', disp='G15.7')
        cols0 = [col1,col2,col3]
        #------ WIL SKIP FOR NOW--------#
        ##STORY MJDs:Dec  7 2006=54076.23;
        #HISTORY MJDs:Dec  5 2007=54439.48;
        #HISTORY MJDs:Mar 09 2012=55995.36;

        #if len(subsubfiles) >= 2 :
        if len(mjd)>= 2:
            name_col = 'MJD#' + str("%.2f" % mjd[1])
            print ' name col 1=',name_col
            col4= py.Column(name=name_col, format='E', array=tt_p,
                    unit='TRANSMISSION', disp='G15.7')
            cols0.append(col4)
        #if len(subsubfiles) >= 3:
        if len(mjd)>= 3:
            name_col = 'MJD#' + str("%.2f" % mjd[2])
            col5= py.Column(name=name_col, format='E',
                    array=tt_p, unit='TRANSMISSION', disp='G15.7')
            cols0.append(col5)
        #if len(subsubfiles) >= 4:
        if len(mjd)>= 4:
            name_col = 'MJD#' + str("%.2f" % mjd[3])
            col6= py.Column(name=name_col, format='E', array=tt_p,
                    unit='TRANSMISSION', disp='G15.7')
            cols0.append(col6)

        cols = py.ColDefs(cols0)
        tbhdu = py.BinTableHDU.from_columns(cols)

        thdulist = py.HDUList([newhdu,tbhdu])
        thdulist.writeto(outfile)

